opal/mca/mca.h File Reference.TH "opal/mca/mca.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/mca/mca.h \- Top-level interface for \fIall\fP MCA components. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/util/cmd_line.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_BASE_MAX_TYPE_NAME_LEN\fP   32"
.br
.RI "\fIMaximum length of MCA framework string names. \fP"
.ti -1c
.RI "#define \fBMCA_BASE_MAX_COMPONENT_NAME_LEN\fP   64"
.br
.RI "\fIMaximum length of MCA component string names. \fP"
.ti -1c
.RI "#define \fBMCA_BASE_VERSION_1_0_0\fP   1, 0, 0"
.br
.RI "\fIMacro for framework author convenience. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBmca_base_open_component_fn_t\fP )(void)"
.br
.RI "\fIMCA component open function. \fP"
.ti -1c
.RI "typedef int(* \fBmca_base_close_component_fn_t\fP )(void)"
.br
.RI "\fIMCA component close function. \fP"
.ti -1c
.RI "typedef \fBmca_base_component_t\fP \fBmca_base_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_base_component_data_1_0_0_t\fP \fBmca_base_component_data_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Enumerations"

.in +1c
.ti -1c
.RI "enum { \fBMCA_SUCCESS\fP =  0, \fBMCA_ERROR\fP =  -1, \fBMCA_ERR_OUT_OF_RESOURCE\fP =  -2, \fBMCA_ERR_TEMP_OUT_OF_RESOURCE\fP =  -3, \fBMCA_ERR_BAD_PARAM\fP =  -5, \fBMCA_ERR_NOT_IMPLEMENTED\fP =  -10, \fBMCA_ERR_NOT_SUPPORTED\fP =  -11, \fBMCA_MAX_ERROR\fP =  -20 }"
.br
.RI "\fIMCA return codes. \fP"
.in -1c
.SH "Detailed Description"
.PP 
Top-level interface for \fIall\fP MCA components. 


.SH "Define Documentation"
.PP 
.SS "#define MCA_BASE_VERSION_1_0_0   1, 0, 0"
.PP
Macro for framework author convenience. 
.PP
This macro is used by frameworks defining their component types, indicating that they subscribe to the MCA version 1.0.0. See component header files (e.g., \fBcoll.h\fP) for examples of its usage. 
.SH "Typedef Documentation"
.PP 
.SS "typedef int(* \fBmca_base_close_component_fn_t\fP)(void)"
.PP
MCA component close function. 
.PP
\fBReturn values:\fP
.RS 4
\fIMCA_SUCCESS\fP The component successfully shut down.
.br
\fIany_other_value\fP Some error occurred, but is likely to be ignored.
.RE
.PP
This function is invoked on a component after all of its modules have been finalized (according to the rules of its framework) and the component will never be used in the process again; the component may be unloaded from the process memory after the close function has been invoked.
.PP
This function is typically used to release any resources still in use by the component.
.PP
If the component has no resources to free, it may provide NULL for this function. In this case, the MCA will act as if it called the close function and it returned MCA_SUCCESS. 
.SS "typedef int(* \fBmca_base_open_component_fn_t\fP)(void)"
.PP
MCA component open function. 
.PP
\fBReturn values:\fP
.RS 4
\fIMCA_SUCCESS\fP This component can be used in the process.
.br
\fIanything_else\fP The MCA will ignore this component for the duration of the process.
.RE
.PP
All MCA components can have an 'open' function that is invoked once per process, when the component is located and loaded. This function should register any MCA parameters (using \fBmca_base_param_register_int()\fP and \fBmca_base_param_register_string()\fP) that will be used by the component. Parameter registrations should occur in this function because the ompi_info command can be used by users to display all available MCA parameters (and their default values). However, the ompi_info command \fIonly\fP invokes this open function on all components (i.e., no other component API methods).
.PP
This function can also be used to allocate any resources necessary for the component (e.g., heap memory).
.PP
This function should return MCA_SUCCESS if it wishes to remain loaded in the process. Any other return value will cause the MCA base to unload the component. Although most components do not use this mechanism to force themselves to be unloaded (because if they are immediately unloaded, ompi_info will not display them), the mechanism is available should the need arise.
.PP
If the component a) has no MCA parameters to register, b) no resources to allocate, and c) can always be used in a process (albiet perhaps not selected), it may provide NULL for this function. In this cause, the MCA will act as if it called the open function and it returned MCA_SUCCESS. 
.SH "Enumeration Type Documentation"
.PP 
.SS "anonymous enum"
.PP
MCA return codes. 
.PP
\fBEnumeration values: \fP
.in +1c
.TP
\fB\fIMCA_SUCCESS \fP\fP
Success. 
.TP
\fB\fIMCA_ERROR \fP\fP
General error. 
.TP
\fB\fIMCA_ERR_OUT_OF_RESOURCE \fP\fP
Out of resources; a fatal error. 
.TP
\fB\fIMCA_ERR_TEMP_OUT_OF_RESOURCE \fP\fP
Out of resources; try again later. 
.TP
\fB\fIMCA_ERR_BAD_PARAM \fP\fP
Equivalent to MPI_ERR_ARG error code. 
.TP
\fB\fIMCA_ERR_NOT_IMPLEMENTED \fP\fP
Returned by functions or functionality that has not yet been implemented. 
.TP
\fB\fIMCA_ERR_NOT_SUPPORTED \fP\fP
Returned by functionality that is not supported. 
.TP
\fB\fIMCA_MAX_ERROR \fP\fP
Maximum error code. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
